package vintageLocos;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

public class Locomotive {

    private final String name;
    private final String builder;

    private final LocalDate buildDate;

    private final int gauge;

    private final int weight;
    private final int maxSpeed;

    public Locomotive(String name, String builder, LocalDate buildDate, int gauge, int weight, int maxSpeed) {
        this.name = name;
        this.builder = builder;
        this.buildDate = buildDate;
        this.gauge = gauge;
        this.weight = weight;
        this.maxSpeed = maxSpeed;
    }

    public String getName() {
        return name;
    }

    public String getBuilder() {
        return builder;
    }

    public LocalDate getBuildDate() {
        return buildDate;
    }

    public int getGauge() {
        return gauge;
    }

    public int getWeight() {
        return weight;
    }

    public int getMaxSpeed() {
        return maxSpeed;
    }

    @Override
    public String toString() {
        LocalDate date = LocalDate.from(getBuildDate());

        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd.MM.yyyy");

        String formattedDate = date.format(formatter);

        return String.format("This %s is made by %s at %s." ,getName() , getBuilder(), formattedDate);
    }
}
